/*
    Simple calculator

    This program implements a basic expression calculator.
    Input from cin; output to cout.

    This is the integer version!

    The grammar for input is:

    Calculation:
        Statement
        Print
        Quit
        Help
        Calculation Statement

    Statement:
        Declaration
        Expression

    Declaration:
        "let" Name "=" Expression
        "const" name "=" Expression

    Name:
        letter
        letter Sequence

    Sequence:
        letter
        digit
        "_"
        letter Sequence
        digit Sequence
        "_" Sequence

    Print:
        ";"

    Quit:
        "quit"

    Help
        "help"

    Expression:
        Term
        Expression "+" Term
        Expression "-" Term

    Term:
        Primary
        Term "*" Primary
        Term "/" Primary
        Term "%" Primary

    Primary:
        Number
        "(" Expression ")"
        "-" Primary
        "+" Primary
        "sqrt(" Expression ")"
        "pow(" Expression "," Integer ")"
        Name
        Name "=" Expression

    Number:
        floating-point-literal

    Input comes from cin through the Token_stream called ts.
*/

#include "..\std_lib_facilities.h"

#include "calculator.h"
//#include <iostream>

// -----------------------------------------------------------------------

int main()
try
{
    // predefine names:
    //st.declare("pi",3.1415926535,true);
    //st.declare("e",2.7182818284,true);
    //st.declare("k",1000,true);

    string fstr;
    float x{0};
    std::cout << "\nEnter the function string you want to evaluate in terms of x: ";
    getline(cin,fstr);
    std::cout << "\nEnter a value for x: ";
    cin >> x;
    string fstring = "let x = " + to_string(x) + "; " + fstr;
    //std::stringstream ss(fstring);
    std::cout << "\nf(" << x << ") = " << calc(fstring);

    return 0;
}
catch (exception& e) {
    cerr << "exception: " << e.what() << endl;
    char c;
    while (cin>>c && c!=';');
    return 1;
}
catch (...) {
   cerr << "exception\n";
    char c;
    while (cin>>c && c!=';');
    return 2;
}
